program Gra_w_rozdzielczosci_320x200x256;
(*{$I-,R-,G+,S-,D+,Q-,V-}*)
{$I-,R+,G+,S+,D+,Q-}
{$M 10000,10000,650000}
uses CRT,DOS,SINCOS,MOUSE;
type
     T_Levels    =  record
                       Max_Flying : word;
                       tab        : array[1..1000] of
                                         record x,y   : word;
                                                which : byte;
                                         end;
                    end;


     bufor  = array [1..$FFFF] of byte;           { Do wczytywania BMP }
     paleta = array [1..256] of record r,g,b : byte; end;  { Na palet }

     what_p     = ^boolean;
     what_c     = ^word;
     scan       = record  pressed   : what_p;   { Ktrej zmiennej uy }
                          count     : what_c;   { Ktr zmienn INC    }
                          max       : byte;     { Max. byte'w na znak }
                          codes     : array[1..6] of byte; { ScanCode  }
                          codes_out : array[1..6] of byte; { BreakCode }
                  end;

     T_BMP_Sprite = record
                          x,y  : word;        { Max X i Max Y BitMap'y }
                          size : word;   { Ilo przydzielonej pamici }
                          data : ^bufor;          { Wskanik do danych }
                          pal_exist : boolean;     { Czy paleta jest ? }
                          pal  : ^paleta;   { IF Thus to wsk do palety }
                    end;

     T_Animation = array [1..3] of
                       record
                          used   : boolean;     { Czy klatka uywana ? }
                          name   : string[15];  { Nazwa BMP dla klatki }
                          xp,yp  : word;        { Wsp. do pocz. statku }
                          xmax,ymax : word;     { Wys. & Szer. statku  }
                          Fire_1,Fire_2,Fire_Y : word;   { Wsp. fire'a }
                          point     : T_BMP_Sprite;  { Wsk do Sprite'a }
                       end;

const
     BETA_test   =  True;
     BETA_dir    =  'c:\temp\gra\bmp\';
{ Kolory }
     Black       =   0;
     Blue        = 100;
     Green       =  66;
     Cyan        =   0;
     Red         =  60;
     Magenta     =   0;
     Brown       =  37;
     LightGray   = 240;
     DarkGray    = 128;
     LightBlue   = 198;
     LightGreen  = 146;
     LightCyan   =   0;
     LightRed    = 102;
     LightMagenta=   0;
     Yellow      = 254;
     White       = 255;
     TxtCol_1st  :  byte = LightGreen;          { Color Textu }
     TxtCol_2nd  :  byte = Green;

     MAX_Alian   = 8;
     MAX_Ship    = 8;
     MAX_Boom    = 8;
     MAX_Explode = 50;


     Yes = True;
     No  = False;


(*********** Nazwy i pointery do statkw obcych ***************)
     Alian_Ship   :  array [1..MAX_Alian] of
                           record
                                 used        : boolean;    { Is used ? }
                                 score       : word;
                                 Anim        : T_Animation;
                           end =
((used:Yes;score:1000;Anim:
                ((used:Yes; name:'saucer1.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:Yes; name:'saucer2.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:Yes; name:'saucer3.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18))),
 (used:yes;score:1000;Anim:
                ((used:Yes; name:'rak1.bmp';    xp:1; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:No;  name:'saucer2.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:No;  name:'saucer3.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18))),
 (used:yes;score:1000;Anim:
                ((used:Yes; name:'rak_c1.bmp';  xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:No;  name:'saucer2.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:No;  name:'saucer3.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18))),
 (used:yes;score:1000;Anim:
                ((used:Yes; name:'sauc_c1.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:No;  name:'saucer2.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:No;  name:'saucer3.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18))),
 (used:yes;score:1000;Anim:
                ((used:Yes; name:'ship_c.bmp';  xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:No;  name:'saucer2.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18),
                 (used:No;  name:'saucer3.bmp'; xp:6; yp:2; xmax:42; ymax:45; Fire_1:9; Fire_2:39; Fire_Y:18))),
 (used:No),(used:No),(used:No));


 (********** Nazwy i pointery do statkw ziemskich ************)
     Space_Ship   : array [1..MAX_Ship] of
                          record
                                used        : boolean;     { Is used ? }
                                Anim        : T_Animation;
                          end =
((used:Yes;Anim:
               ((used:Yes; name:'ship1.bmp'; xp:0; yp:0; xmax:40; ymax:35; Fire_1:13; Fire_2:26; Fire_Y:5),
                (used:Yes; name:'ship2.bmp'; xp:0; yp:0; xmax:40; ymax:35; Fire_1:13; Fire_2:26; Fire_Y:5),
                (used:Yes; name:'ship3.bmp'; xp:0; yp:0; xmax:40; ymax:35; Fire_1:13; Fire_2:26; Fire_Y:5))),
 (used:No),(used:No),(used:No),(used:No),(used:No),(used:No),(used:No));



 (********** Nazwy i pointery do wybuchw ************)
     Boom_Anim   : array [1..MAX_Boom] of
                          record
                                used        : boolean;     { Is used ? }
                                Anim        : T_Animation;
                          end =
((used:Yes;Anim:
               ((used:Yes; name:'boom1.bmp'; xp:0; yp:2; xmax:40; ymax:45),
                (used:Yes; name:'boom2.bmp'; xp:0; yp:2; xmax:42; ymax:45),
                (used:Yes; name:'boom3.bmp'; xp:0; yp:2; xmax:42; ymax:45))),
 (used:No),(used:No),(used:No),(used:No),(used:No),(used:No),(used:No));



     step_X     =  7;
     step_Y     =  7;
     Max_stars  =  50;
     xp         =  84;
     xk         =  320-8;
     yp         =  0;
     yk         =  200;
     Font1_name =  'FONTS#1.FON';
     Font2_name =  'FONTS#2.FON';
     FightBk    =  'tlo1.bmp';
     IntroBk    =  'stat1.bmp';
     Move_Back  =  'Luna.BMP';

     x_statku   :  word = xp + (xk-xp) div 2;        { Pozycja statku }
     y_statku   :  word = yk - 50;
     MAX_Flying :  word = 0;
     MAX_Alian_Loaded : word = 0;


type virtual_bufor = array[0..199+4,0..319] of byte; { Ekran roboczy }
     dword         = longint;
     BMP_File_Hdr_Type = record                      { *** BMP Header *** }
                           bfType    : word;         { 'BM' }
                           bfSize    : dword;        { Wiel caego BMP }
                           bfReserve1,
                           bfReserve2: word;
                           bfOFFBits : dword;        { Offset do danych }
                         end;
     BMP_Info_Hdr_Type = record                      {  *** BMP info ***  }
                           biSize    : dword;        { const 40 }
                           biWidth   : dword;        { Szeroko }
                           biHeight  : dword;        { Wysoko }
                           biPlanes  : word;         { Paty }
                           biBitCount: word;         { Bit na Pixel }
                           biCompression   : dword;  { 0 = w/o compresji }
                           biSizeImage     : dword;  { Wiel danych }
                           biXPelsPerMeter : dword;
                           biYPelsPerMeter : dword;
                           biClrUsed       : dword;
                           biClrImportant  : dword;
                         end;

     T_font     = array [1..10] of
                  record
                        used      : boolean;     { Is used ? }
                        count     : byte;        { Chyba Max ilo liter }
                        xmax,ymax : word;        { Wys. & Szer. liter }
                        size      : word;        { Wielko pamici dla point }
                        point     : pointer;     { pointer to font }
                  end;

     T_In_Fly_Ships = record
                        fly       : boolean;     { In fly ? }
                        count     : byte;        { Odliczanie ktra animacja }
                        tym       : byte;        { Tym na odczekiwanie }
                        xpos,ypos : integer;     { Pozycja statku }
                        accel     : byte;        { Przypieszenie }
                        score     : word;
                        anim      : ^T_Animation;{ Do sekwencji animacji }
                      end;
     T_Explode      = record                     { Explode na gwiazdy }
                        used      : boolean;     { Is used ? }
                        xpos,ypos : integer;     { Pocztkowa pozycja wybuchu }
                        add,accel : word;        { Add - przemieszczenie }
                        TheEnd    : byte;        { Ile jeszcze gwiazd w locie }
                        explode   : array[1..max_explode] of
                                         record
                                             kat,odl : word;
                                             max     : byte;  { Max odl }
                                         end;
                      end;

      T_Button = object
                   xp,yp,xk,yk : word;
                   title       : string;
                   run         : procedure;
                   constructor Init(xpos,ypos: word; text: string; func: pointer);
                   function  Pressed(xm,ym: word): boolean;
                   function  Is_on_button(xm,ym: word): boolean;
                   procedure Button_In;
                   procedure Button_Out;
                 end;
      T_Scroll = object(T_button)
                   constructor Init(xpos,ypos: word; text: string; func: pointer);
                   function  Pressed(xm,ym: word): boolean;
                   function  Is_on_Button(xm,ym: word): boolean;
                 end;

(*********** Z M I E N N E
 ***********)
     var  virtual_screen  : ^virtual_bufor;      { Ekran roboczy          }
          s_virt,o_virt   : word;                { Na seg i ofs roboczego }
          In_Fly_Ships    : array [1..100] of T_In_Fly_Ships;  { Statki w ruchu }
          Crashed_Ships   : array [1..100] of T_In_Fly_Ships;  { Wybuch         }
          Explode_Ships   : array [1..100] of T_Explode;       { Rozszczepienie }
          bomb            : array [1..100] of record x,y : word; fly : boolean; end;
          Fighter_Ship    : T_In_Fly_Ships;      { Statek szczelajcy     }
          font            : T_font;              { Czcionki               }
          BMP_tlo         : T_BMP_Sprite;        { Przesuwajce si to   }
          i,j             : word;                { Dla ptli              }
          oldexitproc     : pointer;
          HEAP_state      : pointer;
          sciezka_EXE     : string[50];
          frame           : byte;
          xm,ym,st,tm     : word;

var   ALIANS_POS : word;
      Levels     : ^T_Levels;
      ch         : char;
      tlo        : T_BMP_Sprite;
      Accel      : word;
      xo,yo      : word;
      x,y        : word;
      oldsize    : word;
      xt,yt,wys  : integer;
      stng       : string;
      Button_Up_Ship,Button_Undo,Button_Down_Ship,
      Button_save,Button_load,Button_new,Button_quit,
      Button_pgup,Button_pgdn : T_Button;
      Button_up,Button_down : T_Scroll;





procedure initgraph256; assembler;
asm
        mov     ax,0013h
        int     10h
end;

procedure txt_mode; assembler;
asm
        mov     ah,0fh
        int     10h
        cmp     al,03h
        jz      @Juz_w_textowym

        mov     ax,0003h
        int     10h

@Juz_w_textowym:
end;

procedure clrscr(atr: byte); assembler;     { IN:  Atrybut }
asm
        mov     ax,0600h
        mov     bh,atr
        xor     cx,cx
        mov     dx,184fh
        int     10h
end;

procedure putchar(znak,atr: byte; ile: word); assembler;
asm
        mov     ah,0fh
        int     10h                         { Return in BH active page }

        mov     ah,09h
        mov     al,znak
        mov     bl,atr
        mov     cx,ile
        int     10h
end;

procedure GotoXY(x,y: byte); assembler;
asm
        mov     ah,0fh
        int     10h                         { Return in BH active page }

        mov     ah,02h
        mov     dh,y
        mov     dl,x
        int     10h
end;

procedure putstring(x,y,atr: byte; napis: string);
var s,o: word;
begin
s:=seg(napis);                  { Trzeba tak bo gnj (pascal) co le }
o:=ofs(napis);                  { podkada adres jak si robi w ASM.  }
asm
        mov     ah,0fh
        int     10h                         { Return in BH active page }

        push    es
        push    bp

        mov     dl,x
        mov     dh,y
        mov     bl,atr
        mov     es,s
        mov     bp,o
        xor     ch,ch
        mov     cl,byte ptr es:[bp]
        inc     bp
        mov     ax,1301h
        int     10h

        pop     bp
        pop     es
end;
end;



procedure clear_keyboard; assembler;
asm
@Czysc:
        mov     ah,11h              { IS keypressed ? }
        int     16h
        jz      @koniec

        mov     ah,10h              { Pressed }
        int     16h
        loop    @Czysc

@koniec:
end;

procedure Set_max_speed; assembler;
asm
        mov     al,0f3h
        out     60h,al
@wait:
        in      al,64h
        test    al,02h
        jnz     @wait

        xor     al,al
        out     60h,al
end;




{$F+}
procedure MyExitProc; far;
begin
Release(HEAP_state);               {  Zwolnienie pamieci  }

if ExitCode<>0 then
   begin
        txt_mode;
        write('FATAL: Very fatal error (no: ',ExitCode,'), ');
   end;
case ExitCode of
  0 : ;
  2 : writeln('File not found.');
  3 : writeln('Path not found.');
  4 : writeln('Too many open files. (Set eg. FILES=20 in CONFIG.SYS)');
  5 : writeln('File access denied.');
100 : writeln('Disk read error.');
101 : writeln('Disk write error.');
106 : writeln('Invalid numeric format.');
150 : writeln('Disk is write protected.');
152 : writeln('Disk not ready.');
162 : writeln('Hardware error.');
200 : writeln('Division by zero.');
201 : writeln('Range check error.');
202 : writeln('Stack overflow error.');
203 : writeln('Heap overflow (not enough memo?).');
204 : writeln('Invalid pointer operation.');
255 : writeln('[!] Ctrl-Break pressed [!] (What for?)');
Else Writeln('Unanticipated error. Report kindly requested.');
end;
if ExitCode<>0 then writeln('PROGRAM HALTED.');
exitproc:=oldexitproc;
end;
{$F-}


procedure the_end;
begin
Release(HEAP_state);               {  Zwolnienie pamici  }
clear_keyboard;
memW[$0:$417]:=0;                  { Wyzerowanie stanu specjalnych }
Txt_Mode;

ClrScr(15);
GotoXY(0,0);
putchar(32,31,80);
putstring((80 shr 1) - Length('LEVEL MAKER for MOON SWEEPER') shr 1,0,31,'LEVEL MAKER for MOON SWEEPER');
GotoXY(0,2);
IF ExitCode=0 Then Writeln('Smooth exit...');
writeln;

writeln('Maximum memo available under 640k  :  ',MemAvail:6,'B');
writeln('Largest continues block available  :  ',MaxAvail:6,'B');
writeln;

writeln;
halt;
end;

procedure Check4Error(name: string);
var  Blad : Integer;
begin
     Blad:=IOResult;
     IF Blad=0 Then Exit;
     txt_mode;
     Writeln('FATAL: Was an error [no. ',Blad,'] while reading resource file.');
     Writeln('       Name of file is: <',name,'>,');
     Write  ('       check for his existing.  ');
     Writeln('PROGRAM HALTED');
     Halt;
end;


procedure setrgbpal(s,o:word); assembler;       { Set RGB palete colorow }
asm                                             { Proc zapisu palety RGB  }
        push    ds
        mov     ds,ss:s
        mov     si,ss:o

        mov     cx,256*3
        mov     dx,3c8h
        xor     al,al
        out     dx,al
        inc     dx
        cld
@petel:
        outsb
        loop    @petel
        pop     ds
end;


procedure getrgbpal(s,o:word); assembler;
asm                        { Proc odczyt palety RGB }
{        push    es
        mov     es,ss:s
        mov     di,ss:o
        mov     cx,256*3
        mov     dx,3c8h
        mov     ax,1
        out     dx,ax
        inc     dx
        cld
        rep     insb
        pop     es}
   mov  ax,1017h
   mov  es,s
   mov  dx,o
   xor  bx,bx
   mov  cx,$100
   int  10h
end;

procedure move_data;assembler;
     asm
         cli
         mov    dx,03DAh
@Vert:   in     al,dx               { Czeka na pionowy, 3bit=1 }
         test   al,08h
         je     @Vert

@Wait:   in     al,dx               { Czeka a 0bit=0 (faza ciemna)}
         rcr    al,1
         jc     @Wait

         push ds
         xor  si,si
         mov  ds,[ds:s_virt]
         xor  di,di
         mov  dx,0a000h
         mov  es,dx
         mov  cx,16000       {  64000 / 4  }
         cld
db $66;  rep  movsw          {  REP  MOVSD  (32bit)  }
         pop  ds
         sti
     end;

procedure line(xp,yp,xk,yk: word; col: byte); assembler;
var wsk1    : word;
    wsk2    : word;
    podpr   : word;
asm
        push    si
        push    di
        mov     es,ds:s_virt
        mov     si,320
        mov     cx,xk
        sub     cx,xp
        jz      @VL
        jns     @pdr1
        neg     cx
        mov     bx,xk
        xchg    bx,xp
        mov     xk,bx
        mov     bx,yk
        xchg    bx,yp
        mov     yk,bx
@pdr1:
        mov     bx,yk
        sub     bx,yp
        jz      @HL
        jns     @pdr3
        neg     bx
        neg     si
@pdr3:
        push    si
        mov     podpr,offset @LL1
        cmp     bx,cx
        jle     @pdr4
        mov     podpr,offset @HL1
        xchg    bx,cx
@pdr4:
        shl     bx,1
        mov     wsk1,bx
        sub     bx,cx
        mov     si,bx
        sub     bx,cx
        mov     wsk2,bx
        push    cx
        mov     ax,yp
        mov     bx,xp
        xchg    ah,al
        add     bx,ax
        shr     ax,2
        add     bx,ax

        mov     di,bx
        pop     cx
        inc     cx
        pop     bx
        jmp     podpr
@VL:
        mov     ax,yp
        mov     bx,yk
        mov     cx,bx
        sub     cx,ax
        jge     @pdr31
        neg     cx
        mov     ax,bx
@pdr31:
        inc     cx
        mov     bx,xp
        push    cx

        xchg    ah,al
        add     bx,ax
        shr     ax,2
        add     bx,ax

        pop     cx
        mov     di,bx
        dec     si
        mov     al,col
@pdr32:
        stosb
        add     di,si
        loop    @pdr32
        jmp     @Exit
@HL:
        push    cx
        mov     ax,yp
        mov     bx,xp
        xchg    ah,al
        add     bx,ax
        shr     ax,2
        add     bx,ax

        mov     di,bx
        pop     cx
        inc     cx
        mov     al,col
        rep     stosb
        jmp     @Exit
@LL1:
        mov     al,col
@pdr11:
        stosb
        or      si,si
        jns     @pdr12
        add     si,wsk1
        loop    @pdr11
        jmp     @Exit
@pdr12:
        add     si,wsk2
        add     di,bx
        loop    @pdr11
        jmp     @Exit
@HL1:
        mov     al,col
@pdr21:
        stosb
        add     di,bx
@pdr22:
        or      si,si
        jns     @pdr23
        add     si,wsk1
        dec     di
        loop    @pdr21
        jmp     @Exit
@pdr23:
        add     si,wsk2
        loop    @pdr21
@Exit:
        pop     di
        pop     si
end;



Function reserve_mem(size: word): pointer;      { Alokacja miejsca w pamici }
var  P: Pointer;
begin
     IF MaxAvail<Size Then
        begin
             txt_mode;
             writeln('FATAL: Not enough memo to continue program.');
             writeln('       Free about over ',Size-MaxAvail,' bytes and try again.');
             writeln('           --- PROGRAM HALTED ---');
             halt;
        end;
     GetMem(P,size);
     Reserve_Mem:=P;
end;




(****************************** Odczyt BMP'w *******************************)
procedure Read_Sprite(path: string; var BMP_Sprite: T_BMP_Sprite);
Type
    tab = array [1..256] of record
                                  r,g,b,nic : byte;
                            end;
Var i          : word;
    bmp        : file;
    BMPFileHdr : ^BMP_File_Hdr_Type;
    BMPInfoHdr : ^BMP_Info_Hdr_Type;
    Tym        : ^tab;
    Head       : dword;
    Xmax,Ymax  : integer;
    P          : pointer;
begin
FileMode:=0;
assign(bmp,path);
reset(bmp,1);
Check4Error(path);

BMPFileHdr:=Reserve_Mem(SizeOf(BMP_File_Hdr_Type));
BMPInfoHdr:=Reserve_Mem(SizeOf(BMP_Info_Hdr_Type));
BlockRead(bmp,BMPFileHdr^,SizeOf(BMP_File_Hdr_Type));
BlockRead(bmp,BMPInfoHdr^,SizeOf(BMP_Info_Hdr_Type));
IF (BMPFileHdr^.bfType<>256*77+66) or (BMPInfoHdr^.biPlanes<>1) or
   (BMPInfoHdr^.biBitCount<>8) or (BMPInfoHdr^.biCompression<>0) Then
   begin
        txt_mode;
        writeln('FATAL: Unsupported BMP file.');
        writeln('       File name: [',path,'].');
        close(bmp);
        halt;
   end;
Xmax:=BMPinfoHdr^.biWidth;
Ymax:=BMPInfoHdr^.biHeight;
Head:=BMPFileHdr^.bfOffBits;
If xmax mod 4<>0 then xmax:=(trunc(xmax/4))*4+4;
FreeMem(BMPFileHdr,SizeOf(BMP_File_Hdr_Type));
FreeMem(BMPInfoHdr,SizeOf(BMP_Info_Hdr_Type));


Tym:=Reserve_Mem(SizeOf(tab));
BMP_Sprite.Pal:=Reserve_Mem(SizeOf(paleta));
seek(bmp,$36);
BlockRead(bmp,Tym^,sizeof(Tab));               { Get Palette from BMP }
for i:=1 to 256 do
    begin
         BMP_Sprite.Pal^[i].R:=Tym^[i].B shr 2;
         BMP_Sprite.Pal^[i].G:=Tym^[i].G shr 2;
         BMP_Sprite.Pal^[i].B:=Tym^[i].R shr 2;
    end;
FreeMem(Tym,SizeOf(tab));


BMP_Sprite.Data:=Reserve_Mem(FileSize(BMP)-head);

Seek(BMP,Head);
BlockRead(BMP,BMP_Sprite.Data^,FileSize(BMP)-Head);
BMP_Sprite.X:=Xmax;
BMP_Sprite.Y:=Ymax;
BMP_Sprite.Size:=FileSize(BMP)-head;
BMP_Sprite.Pal_Exist:=True;

close(bmp);
end;



procedure fade_down;
var   pal : array [1..769] of byte;
      i,j : word;
begin
GetRGBpal(seg(pal),ofs(pal));
For j:=1 to 63 do
    begin
         for i:=1 to 769 do
             if pal[i]<>0 then dec(pal[i]);
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         SetRGBpal(seg(pal),ofs(pal));
    end;
end;

procedure fade_up(s,o: word);
var   pal  : array [1..769] of byte;
      i,j  : word;
begin
FillChar(pal,SizeOf(pal),#0);
For j:=1 to 63 do
    begin
         for i:=1 to 769 do
             begin
                  if pal[i]<mem[s:o+i-1] then Inc(pal[i])
                                       Else
                  if pal[i]>mem[s:o+i-1] then Dec(pal[i]);
             end;
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         SetRGBpal(seg(pal),ofs(pal));
         delay(1);
    end;
end;


(************************** Nakadanie rysunkw *****************************)
procedure get_background(xp,yp: word; var Input: T_BMP_Sprite; var back: T_BMP_Sprite);
var   tym_ofs   : word;
      xmax,ymax : word;
      s_data,
      o_data    : word;
begin
      s_data:=Seg(Back.Data^);
      o_data:=Ofs(Back.Data^);
      xmax:=input.x;
      ymax:=input.y;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      Back.Y:=InPut.Y;
      Back.X:=InPut.X;
      Back.Size:=InPut.Size;
      Back.Pal_Exist:=False;
asm   push  ds
      mov   di,ss:o_data
      mov   si,ss:tym_ofs
      mov   es,ss:s_data
      mov   ds,ds:s_virt
      mov   dx,ss:ymax             { Y-ki maxymalne }
      mov   cx,ss:xmax             { X-y  maxymalne }
      cld
@petla_Y:

      push  cx
      push  si
      rep   movsb                  { Rysowanie lini }
      pop   si
      pop   cx

      sub   si,320                 { Lini do tyu w wirtualnym ekranie }
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;

procedure put_image(xp,yp: word; var  InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.X;
      ymax:=InPut.Y;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);

asm   push  ds
      mov   si,[ss:o_data]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  di
      push  cx
      rep   movsb                 { Linia X-w }
      pop   cx
      pop   di

      sub   di,320                { O 1- lini do tyu }
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure put_image_and_backup(xp,yp: word; var InPut: T_BMP_Sprite; var BackGr: T_BMP_Sprite);
var   tym_ofs   : word;
      Xmax,Ymax : word;
      s_data,
      o_data    : word;
      s_back,
      o_back    : word;
      s_virt_   : word;
begin
      xmax:=InPut.X;
      ymax:=InPut.Y;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
      s_back:=Seg(BackGr.Data^);
      o_back:=Ofs(BackGr.Data^);
      s_virt_:=s_virt;
asm   push  ds
      xor   si,si
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      mov   ds,ss:s_virt_
      mov   es,ss:s_back
      push  si
      push  di
      xchg  si,di
      add   di,ss:o_back
      rep   movsb
      pop   di
      pop   si
      pop   cx

      push  cx
      mov   es,ss:s_virt_
      mov   ds,ss:s_data
      push  di
      push  si
      add   si,ss:o_data
      rep   movsb
      pop   si
      pop   di
      pop   cx

      add   si,ss:xmax
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
      BackGr.X:=InPut.X;
      BackGr.Y:=InPut.Y;
      BackGr.Size:=InPut.Size;
end;


procedure put_sprite_and_backup(xp,yp: word; var InPut: T_BMP_Sprite; var BackGr: T_BMP_Sprite);
var   tym_ofs   : word;
      Xmax,Ymax : word;
      s_data,
      o_data    : word;
      s_back,
      o_back    : word;
      s_virt_   : word;
begin
      xmax:=InPut.X;
      ymax:=InPut.Y;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
      s_back:=Seg(BackGr.Data^);
      o_back:=Ofs(BackGr.Data^);
      s_virt_:=s_virt;
asm   push  ds
      xor   si,si
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      mov   ds,ss:s_virt_
      mov   es,ss:s_back
      push  si
      push  di
      xchg  si,di
      add   di,ss:o_back
      rep   movsb
      pop   di
      pop   si
      pop   cx

      push  cx
      mov   es,ss:s_virt_
      mov   ds,ss:s_data
      push  di
      push  si
      add   si,ss:o_data
  @Petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @Go
      movsb
  loop      @petla_X
      jmp   @koniec
  @Go:
      inc   si
      inc   di
  loop      @petla_X

@koniec:
      pop   si
      pop   di
      pop   cx

      add   si,ss:xmax
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
      BackGr.X:=InPut.X;
      BackGr.Y:=InPut.Y;
      BackGr.Size:=InPut.Size;
end;




procedure put_sprite(xp,yp: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.X;
      ymax:=InPut.Y;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      push  di


  @petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @go
      movsb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
      inc   si
  loop  @petla_X

@koniec:
      pop   di
      pop   cx
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure put_sprite_updown(xp,yp: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
      tym       : word;
begin
      xmax:=InPut.X;
      ymax:=InPut.Y;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*yp;
      tym:=320-xmax;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx


  @petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @go
      movsb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
      inc   si
  loop  @petla_X

@koniec:
      pop   cx
      add   di,tym
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;



procedure put_sprite_from_to(xp,yp,From_pos,To_pos: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.X;
      ymax:=InPut.Y;
      IF ymax-to_pos<=from_pos Then exit;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax-from_pos-to_pos)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^)+to_pos*xmax;
      ymax:=ymax-(from_pos+to_pos);
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      push  di


  @petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @go
      movsb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
      inc   si
  loop  @petla_X

@koniec:
      pop   di
      pop   cx
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;




procedure put_image_from_to(xp,yp,From_pos,To_pos: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.X;
      ymax:=InPut.Y;
      IF ymax-to_pos<=from_pos Then exit;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax-from_pos-to_pos)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^)+to_pos*xmax;
      ymax:=ymax-(from_pos+to_pos);

asm   push  ds
      mov   si,[ss:o_data]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  di
      push  cx
      rep   movsb                 { Linia X-w }
      pop   cx
      pop   di

      sub   di,320                { O 1- lini do tyu }
      dec   dx
jne   @petla_Y
      pop   ds
end;


end;


procedure put_image_from_to_updown(xp,yp,From_pos,To_pos: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.X;
      ymax:=InPut.Y;
      IF ymax-to_pos<=from_pos Then exit;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp);
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^)+from_pos*xmax;
      ymax:=ymax-(from_pos+to_pos);

asm   push  ds
      mov   si,[ss:o_data]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  cx
      rep   movsb                 { Linia X-w }
      pop   cx

      add   di,320
      sub   di,ss:xmax

      dec   dx
jne   @petla_Y
      pop   ds
end;


end;




procedure put_block(xp,yp,xk,yk: word; col : byte);  { Wypeniony prostokt }
var   tym_ofs   : word;
      xmax,ymax : word;
      tym_sub   : word;
begin
      xmax:=xk-xp;
      ymax:=yk-yp;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+yp*320;
      tym_sub:=320-xmax;
asm   push  ds
      mov   al,[ss:col]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  cx
      rep   stosb                 { Linia X-w }
      pop   cx

      add   di,ss:tym_sub

      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure Read_on_screen(xp,yp: word; path: string; SwitchPAL,Show_0: boolean);
Type
    tab = array [1..256] of record
                                  r,g,b,nic : byte;
                            end;
Var i          : word;
    bmp        : file;
    BMPFileHdr : ^BMP_File_Hdr_Type;
    BMPInfoHdr : ^BMP_Info_Hdr_Type;
    BMPSprite  : T_BMP_Sprite;
    Tym        : ^tab;
    Head       : dword;
    Xmax,Ymax  : integer;
    P          : pointer;
begin
FileMode:=0;
assign(bmp,path);
reset(bmp,1);
Check4Error(path);


BMPFileHdr:=Reserve_Mem(SizeOf(BMP_File_Hdr_Type));
BMPInfoHdr:=Reserve_Mem(SizeOf(BMP_Info_Hdr_Type));
BlockRead(bmp,BMPFileHdr^,SizeOf(BMP_File_Hdr_Type));
BlockRead(bmp,BMPInfoHdr^,SizeOf(BMP_Info_Hdr_Type));
Xmax:=BMPinfoHdr^.biWidth;
Ymax:=BMPInfoHdr^.biHeight;
Head:=BMPFileHdr^.bfOffBits;
If xmax mod 4<>0 then xmax:=(trunc(xmax/4))*4+4;
FreeMem(BMPFileHdr,SizeOf(BMP_File_Hdr_Type));
FreeMem(BMPInfoHdr,SizeOf(BMP_Info_Hdr_Type));
BMPSprite.Data:=Reserve_Mem(FileSize(BMP)-head);
Seek(BMP,Head);
BlockRead(BMP,BMPSprite.Data^,FileSize(BMP)-Head);
BMPSprite.X:=Xmax;
BMPSprite.Y:=Ymax;
BMPSprite.Size:=FileSize(BMP)-head;
IF Show_0 Then Put_Image(xp,yp,BMPSprite)     { Wywietli z zerem }
          Else Put_Sprite(xp,yp,BMPSprite);   { Naoy bez zera   }

FreeMem(BMPSprite.Data,BMPSprite.Size);

IF SwitchPAL Then                              { Czy ustawi palet }
begin
Tym:=Reserve_Mem(SizeOf(tab));
BMPSprite.Pal:=Reserve_Mem(SizeOf(paleta));
seek(bmp,$36);
BlockRead(bmp,Tym^,sizeof(Tab));               { Get Palette from BMP }
for i:=1 to 256 do
    begin
         BMPSprite.Pal^[i].R:=Tym^[i].B shr 2;
         BMPSprite.Pal^[i].G:=Tym^[i].G shr 2;
         BMPSprite.Pal^[i].B:=Tym^[i].R shr 2;
    end;
FreeMem(Tym,SizeOf(tab));
SetRGBPal(Seg(BMPSprite.pal^),Ofs(BMPSprite.pal^)); { Set RGB-Palette }
FreeMem(BMPSprite.Pal,SizeOf(paleta));
end;


close(bmp);
end;



(********************** Nakadanie textu ************************)
procedure put_char_XY(xp,yp: word; No,ch,col: byte; InPut: T_Font);
var   tym_ofs       : word;
      tym_add       : word;
      s_data,o_data : word;
      xmax,ymax     : word;
begin
      xmax:=InPut[no].Xmax;
      ymax:=InPut[no].Ymax;
      tym_ofs:=xp+320*yp;
      tym_add:=320-xmax;
      s_data:=Seg(InPut[no].Point^);
      o_data:=Ofs(InPut[no].Point^)+ch*Xmax*Ymax;

asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:
      push  cx

  @petla_X:
      lodsb                   { mov   al,ds:[si] & inc si }
      or    al,al
      jz    @go
      mov   al,ss:col
      stosb                   { mov   es:[di],al & inc di }
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
  loop  @petla_X

@koniec:
      pop   cx
      add   di,ss:tym_add
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure put_string_XY(xp,yp: word; No : byte; napis: string; col: byte);
var   tym_ofs       : word;        {  ^ Nr czcionki       Color ^ }
      tym_add       : word;
      s_data,o_data : word;
      xmax,ymax     : word;
      i             : word;
begin
      IF Length(napis)=0 Then exit;
      xmax:=Font[no].Xmax;
      ymax:=Font[no].Ymax;
      tym_ofs:=xp+320*yp;
      tym_add:=320-xmax;
      s_data:=Seg(Font[no].Point^);

      i:=0;
      IF Font[No].Size<>0 Then          { Tzn e to nie ROMfont }
Repeat
      inc(i);
      o_data:=Ofs(Font[no].Point^)+mem[Seg(napis):Ofs(napis)+i]*Xmax*Ymax;
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:
      push  cx

  @petla_X:
      lodsb
      or    al,al
      jz    @go
      mov   al,ss:col
      stosb

  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
  loop  @petla_X

@koniec:
      pop   cx
      add   di,ss:tym_add
      dec   dx
jne   @petla_Y
      pop   ds
end;
      tym_ofs:=tym_ofs+xmax;
until i=Length(napis)
      Else
Repeat
      inc(i);
      o_data:=Ofs(Font[no].Point^)+mem[Seg(napis):Ofs(napis)+i]*Ymax;
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      lodsb
      mov   ah,al
      push  cx
      mov   bx,1
      shl   bx,cl
      shl   bx,1
      mov   al,ss:col
  @petla_X:
      shr   bx,1
      test  ah,bl
      jz    @go
      stosb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
  loop  @petla_X

@koniec:

      pop   cx
      add   di,ss:tym_add
      dec   dx
jne   @petla_Y
      pop   ds
end;
      tym_ofs:=tym_ofs+xmax;
until i=Length(napis)
end;


procedure put_string_shadow(xp,yp: word; No : byte; napis: string; col1,col2: byte);
begin
Put_String_XY(xp-1,yp-1,No,napis,col2);
Put_String_XY(xp-1,yp+1,No,napis,col2);
Put_String_XY(xp+1,yp-1,No,napis,col2);
Put_String_XY(xp+1,yp+1,No,napis,col2);
Put_String_XY(xp-1,yp,No,napis,col2);
Put_String_XY(xp+1,yp,No,napis,col2);
Put_String_XY(xp,yp-1,No,napis,col2);
Put_String_XY(xp,yp+1,No,napis,col2);
Put_String_XY(xp,yp,No,napis,col1);
end;


procedure Load_Font(font_name: string);
Type      T_font    = record
                       ID    :  String[10];
                       info  :  String[20];
                       count :  byte;
                       xmax,
                       ymax  :  word;
                      end;
Var       f     : file;
          tym   : T_Font;
          count : word;
          no    : byte;
begin
     for no:=1 to 100 do IF Font[no].Used=False Then begin count:=no; break end;
     FileMode:=0;                      { Read-Only }
     Assign(f,font_name);
     Reset(f,1);
     Check4Error(font_name);
     BlockRead(f,tym,SizeOF(T_Font));
     IF Tym.ID <> 'PS-font   ' Then
        begin
             Txt_Mode;
             Writeln('FATAL: File <',font_name,'> is not correct.');
             Halt;
        end;
     Check4Error(font_name);
     Font[no].Count:=Tym.Count;
     count:=Tym.Count;                    { Bo liczone od Zera }
     Font[no].Xmax:=Tym.Xmax;
     Font[no].Ymax:=Tym.Ymax;
     Font[no].Size:=Count*Tym.Xmax*Tym.Ymax;
     Font[no].Used:=True;
     Font[no].Point:=Reserve_Mem(Count*Tym.Xmax*Tym.Ymax);
     BlockRead(f,Font[no].Point^,Count*Tym.Xmax*Tym.Ymax);
     Check4Error(font_name);
     Close(F);
end;


procedure load_ROM_fonts;
Var       count : word;
          no    : byte;

Function GetROMFontPointer(no: byte): Pointer;    { No - Numer czcionki }
var      s,o : word;
begin
     asm
        push    bp
        push    es

        mov     ax,1130h
        mov     bh,no
        int     10h
        mov     ax,es
        mov     bx,bp

        pop     es
        pop     bp

        mov     s,ax                  { Adres gdzie skadowane s czcionki }
        mov     o,bx
     end;
     GetROMFontPointer:=Ptr(s,o);
end;

begin
     for no:=1 to 100 do IF NOT Font[no].Used Then begin count:=no; break end;
     no:=count;                     { Znalezienie pierwszego wolnego }
     Font[no].Count:=128;
     Font[no].Xmax:=8;
     Font[no].Ymax:=8;
     Font[no].Size:=0;              { Take oznaczenie e to ROM-font }
     Font[no].Used:=True;
     Font[no].Point:=GetROMfontPointer(3); { Czcionka 8x8 0-128 }

     for no:=1 to 100 do IF NOT Font[no].Used Then begin count:=no; break end;
     no:=count;                     { Znalezienie pierwszego wolnego }
     Font[no].Count:=255;
     Font[no].Xmax:=8;
     Font[no].Ymax:=16;
     Font[no].Size:=0;              { Take oznaczenie e to ROM-font }
     Font[no].Used:=True;
     Font[no].Point:=GetROMfontPointer(6); { Czcionka 8x16 0-255 }
end;

procedure Write_Corner_Status(var Corner_Status: string);
const x_st : word = 0;
      y_st : word = 0;
begin
     IF (x_st=x_statku) and (y_st=y_statku) Then put_string_shadow(xp+1,yp+1,4,Corner_Status,TxtCol_1st,TxtCol_2nd) { Status }
        Else begin
                  Corner_Status:='';                 { Aby status znika }
                  x_st:=x_statku;                    { gdy si poruszy   }
                  y_st:=y_statku;
             end;
end;






{$F+}
procedure clock_handler; interrupt;       { Tylko do testowania }
const count : byte = 0;
var   stng: string[3];
begin
     IF NOT BETA_test then exit;
     Inc(count);
     IF count<18 then exit;
     Str(frame,Stng);
     put_string_xy(31-length('888')*9,1,3,'888',black);
     put_string_xy(31-length(Stng)*9,1,3,stng,white);
     frame:=0;
     count:=0;
end;
{$F-}




procedure init_procedures;
begin
clrscr(15);
GotoXY(0,0);
putchar(32,31,80);
putstring((80 shr 1) - Length('LEVEL MAKER for MOON SWEEPER') shr 1,0,31,'LEVEL MAKER for MOON SWEEPER');
GotoXY(0,2);
putchar(Ord(''),11,80);
GotoXY(20,4);
writeln('Please send stinger rocket to the SPA.');
GotoXY(0,6);
putchar(Ord(''),11,80);
GotoXY(0,10);
Writeln('Initial process...');
writeln;

writeln('Maximum memo available under 640k  :  ',MemAvail:6,'B');
writeln('Largest continues block available  :  ',MaxAvail:6,'B');
writeln;
randomize;

if NOT BETA_test then
   begin
        sciezka_EXE:=paramstr(0);          { Wydubanie scieki uruchomienia }
        for i:=length(sciezka_EXE) downto 1 do
            if copy(sciezka_EXE,i,1)='\' then break
                                         else delete(sciezka_EXE,i,1);
   end           Else sciezka_EXE:=BETA_Dir;


write('Init virtual screen... ');
virtual_screen:=Reserve_Mem($FFFF);
s_virt:=Seg(virtual_screen^);       { Seg & Ofs ekranu wirtualnego do zmiennych }
o_virt:=Ofs(virtual_screen^);       { Nie uywane bo si mieci w caym seg     }
writeln('ok.');

write('Loading fonts... ');
load_ROM_Fonts;
load_font(sciezka_EXE+font1_name);
load_font(sciezka_EXE+font2_name);
writeln(' ok.');

FillChar(virtual_screen^, $FFFF, 0);       { Clean-Up }
FillChar(Bomb, SizeOf(bomb), 0);
FillChar(Crashed_Ships, SizeOf(Crashed_Ships), 0);
FillChar(Explode_Ships, SizeOF(Explode_Ships), 0);
FillChar(In_Fly_Ships,  SizeOF(In_Fly_Ships),  0);

Clear_Keyboard;
Set_MAX_speed;                      { ...of keyboard rate }

OldExitProc:=ExitProc;              { Podczepienie mojego epilogu pod RunTime }
ExitProc:=@MyExitProc;
end;



procedure Check_processor;
function i86check: boolean; assembler;     { Spr. czy to 80x86 }
asm
        pushf
        xor     dx,dx
        push    dx
        popf
        pushf
        pop     ax
        cmp     ax,0f000h
        jz      @ThisIs86
        xor     ax,ax
        jmp     @kon

@ThisIs86:
        mov     ax,1
@kon:
        popf
end;
function i286check: boolean; assembler;
asm
        pushf
        mov     ax,0f000h
        push    ax
        popf
        pushf
        pop     ax
        and     ax,0f000h
        jz      @ThisIs286
        xor     ax,ax
        jmp     @kon2

@ThisIs286:
        mov     ax,1
@kon2:
        popf
end;


begin
write('CPU detected: ');
if i86check then
   begin
        writeln('80086 or 80088 (XT). What the fuck ?!');
        writeln('FATAL: Processor is rather old.');
        writeln('       PROGRAM HALTED.');
        writeln('[!] Change processor to +386 and try again.');
        Halt;
   end;

if i286check then
   begin
        writeln('80286 (AT).');
        writeln('FATAL: Processor is rather old.');
        writeln('       PROGRAM HALTED.');
        writeln('[!] Change processor to +386 and try again.');
        Halt;
   end;

writeln('80386 or higher.');
end;


procedure rectangle(xp,yp,xk,yk: word; col: byte);
begin
     Line(xp,yp,xk,yp,col);
     Line(xp,yp,xp,yk,col);
     Line(xk,yp,xk,yk,col);
     Line(xp,yk,xk,yk,col);
end;


procedure Move_BackGround(bmp_tlo: T_BMP_Sprite);
const kier : boolean = true;
      i    : word    = 1;
begin
     dec(i);
IF (i+200>bmp_tlo.y) and (i<bmp_tlo.y) Then
   begin
        IF kier Then
           begin
             put_image_from_to(xp,yp,i,0,bmp_tlo);
             put_image_from_to_updown(xp,yp+bmp_tlo.y-i,0,bmp_tlo.y-(200-(yp+bmp_tlo.y-i)),bmp_tlo)
           end
                Else
           begin
             put_image_from_to_updown(xp,yp,i,0,bmp_tlo);
             put_image_from_to(xp,yp+bmp_tlo.y-i,0,bmp_tlo.y-(200-(yp+bmp_tlo.y-i)),bmp_tlo)
           end;
   end
        else
   begin
        IF kier Then
           put_image_from_to(xp,yp,i,bmp_tlo.y-(i+200),bmp_tlo)
                Else
           put_image_from_to_updown(xp,yp,i,bmp_tlo.y-(i+200),bmp_tlo);
        If i=0 then begin kier:=not kier; i:=bmp_tlo.y; end;
   end;
end;



Function Is_in_rectangle(xq,yq,xp,yp,xk,yk: integer): boolean;
begin
     IF (xq>xp) and (xq<xk) and (yq>yp) and (yq<yk) Then Is_in_rectangle:=True
                                                    Else Is_in_rectangle:=false;
end;



(****************************************************************************)
(****************************************************************************)
procedure UpDate_Crash;                                  { Animacja wybuchw }
var   i,j,count : word;
      xtym,ytym : integer;
      stng      : string[10];
      s_tym,c_tym : longint;      { Dla wymnoenia cosinusw i sinusw }
begin
For i:=1 to 100 do                { Animacja wybuchu }
   IF Crashed_Ships[i].Fly Then
   begin
   IF (Crashed_Ships[i].ypos+10<yk) and (Crashed_Ships[i].ypos>yp) Then
     begin
        str(Crashed_Ships[i].Score,stng);
        put_string_xy(word(Crashed_Ships[i].xpos+11),word(Crashed_Ships[i].ypos+1),4,stng,black);
        put_string_xy(word(Crashed_Ships[i].xpos+10),word(Crashed_Ships[i].ypos),4,stng,lightblue);
     end;

   IF Crashed_Ships[i].Count>3 Then begin Crashed_Ships[i].Fly:=False; continue end
                               Else
   IF (NOT Crashed_Ships[i].Anim^[Crashed_Ships[i].count].Used) Then
      Crashed_Ships[i].Count:=1;
   Count:=Crashed_Ships[i].Count;

   IF (Crashed_Ships[i].ypos>0) and
      (Crashed_Ships[i].ypos+Crashed_Ships[i].anim^[Count].point.y<yk) Then
      put_sprite(Crashed_Ships[i].xpos,Crashed_Ships[i].ypos,Crashed_Ships[i].Anim^[Count].Point);

   IF Crashed_Ships[i].ypos<=0 Then
      IF Crashed_Ships[i].ypos+Crashed_Ships[i].anim^[Count].point.y>yp Then
         put_sprite_from_to(Crashed_Ships[i].xpos,0,
                            abs(Crashed_Ships[i].ypos),0,
                            Crashed_Ships[i].Anim^[Count].Point);

   IF Crashed_Ships[i].ypos+Crashed_Ships[i].anim^[Count].point.y>=yk Then
         put_sprite_from_to(Crashed_Ships[i].xpos,Crashed_Ships[i].ypos,
                            0,Crashed_Ships[i].anim^[Count].point.y-abs(Crashed_Ships[i].ypos-yk),
                            Crashed_Ships[i].Anim^[Count].Point);


   Inc(Crashed_Ships[i].ypos,Crashed_Ships[i].accel);
   IF Crashed_Ships[i].ypos>=yk Then
      begin
           Crashed_Ships[i].ypos:=-100;
           repeat
            Crashed_Ships[i].xpos:=Random(xk-xp)+xp;
           until Crashed_Ships[i].xpos+Crashed_Ships[i].Anim^[Count].xmax<xk;
           Crashed_Ships[i].Accel:=2+Random(4);
      end;
    Inc(Crashed_Ships[i].Tym);                  { Opnienie }
    IF Crashed_Ships[i].Tym=4 Then
       begin Inc(Crashed_Ships[i].Count);
             Crashed_Ships[i].Tym:=0;
       end;
   end;


For i:=1 to 30 do               { Animacja rosprysku na kawaki }
    IF Explode_Ships[i].Used Then
       begin
         For j:=1 to MAX_Explode do
          begin
            inc(Explode_Ships[i].explode[j].Odl,2);
            s_tym:=Explode_Ships[i].explode[j].Odl*sinus_int(Explode_Ships[i].explode[j].Kat);
            c_tym:=Explode_Ships[i].explode[j].Odl*cosinus_int(Explode_Ships[i].explode[j].Kat);
            IF s_tym<0 Then xtym:=Explode_Ships[i].Xpos-Abs(s_tym) shr 13
                       Else xtym:=Explode_Ships[i].Xpos+Abs(s_tym) shr 13;
            IF c_tym<0 Then ytym:=Explode_Ships[i].add+Explode_Ships[i].Ypos-Abs(c_tym) shr 13
                       Else ytym:=Explode_Ships[i].add+Explode_Ships[i].Ypos+Abs(c_tym) shr 13;

            IF ((xtym>xp) and (xtym<xk) and (ytym>yp) and (ytym<yk)) and
                (Explode_Ships[i].explode[j].Odl<Explode_Ships[i].explode[j].max) Then
               virtual_screen^[ytym,xtym]:=Yellow
                                              Else
               Dec(Explode_Ships[i].TheEnd);
            IF Explode_Ships[i].TheEnd=0 Then Explode_Ships[i].Used:=False;
          end;
            inc(Explode_Ships[i].add,Explode_Ships[i].accel);
       end;

end;



procedure UpDate_Alians;               { Poruszanie obcych i check for crash }
var   i,j,k,l : word;
      count : byte;
begin
For i:=1 to MAX_Flying do
IF In_Fly_Ships[i].Fly Then
begin
   Inc(In_Fly_Ships[i].Count);
   IF In_Fly_Ships[i].Count>3 Then In_Fly_Ships[i].Count:=1
                              Else
   IF (NOT In_Fly_Ships[i].Anim^[In_Fly_Ships[i].count].Used) Then
      In_Fly_Ships[i].Count:=1;
   Count:=In_Fly_Ships[i].Count;


   IF (In_Fly_Ships[i].ypos>0) and
      (In_Fly_Ships[i].ypos+In_Fly_Ships[i].anim^[Count].point.y<yk) Then
     put_sprite(In_Fly_Ships[i].xpos,In_Fly_Ships[i].ypos,In_Fly_Ships[i].Anim^[Count].Point);

   IF In_Fly_Ships[i].ypos<=0 Then
      IF In_Fly_Ships[i].ypos+In_Fly_Ships[i].anim^[Count].point.y>yp Then
         put_sprite_from_to(In_Fly_Ships[i].xpos,0,
                            abs(In_Fly_Ships[i].ypos),0,
                            In_Fly_Ships[i].Anim^[Count].Point);

   IF In_Fly_Ships[i].ypos+In_Fly_Ships[i].anim^[Count].point.y>=yk Then
         put_sprite_from_to(In_Fly_Ships[i].xpos,In_Fly_Ships[i].ypos,
                            0,In_Fly_Ships[i].anim^[Count].point.y-abs(In_Fly_Ships[i].ypos-yk),
                            In_Fly_Ships[i].Anim^[Count].Point);


   Inc(In_Fly_Ships[i].ypos,In_Fly_Ships[i].accel);
   IF In_Fly_Ships[i].ypos>=yk Then
      begin
           In_Fly_Ships[i].ypos:=-100;
           repeat
            In_Fly_Ships[i].xpos:=Random(xk-xp)+xp;
           until In_Fly_Ships[i].xpos+In_Fly_Ships[i].Anim^[Count].xmax<xk;
           In_Fly_Ships[i].Accel:=2+Random(4);
      end;

   For j:=1 to 100 do
      IF (Bomb[j].fly) and (Bomb[j].y>In_Fly_Ships[i].ypos) and
         (Bomb[j].y<In_Fly_Ships[i].ypos+In_Fly_Ships[i].anim^[Count].point.y) and
         (Bomb[j].x>In_Fly_Ships[i].xpos) and
         (Bomb[j].x<In_Fly_Ships[i].xpos+In_Fly_Ships[i].anim^[Count].point.x) Then
      begin
           In_Fly_Ships[i].Fly:=False;
           Bomb[j].Fly:=False;
            For j:=1 to 100 do
                IF NOT Crashed_Ships[j].Fly Then
                   begin
                        Crashed_Ships[j].xpos:=In_Fly_Ships[i].xpos;
                        Crashed_Ships[j].ypos:=In_Fly_Ships[i].ypos;
                        Crashed_Ships[j].count:=1;
                        Crashed_Ships[j].tym:=0;
                        Crashed_Ships[j].Anim:=@Boom_Anim[1].Anim;
                        Crashed_Ships[j].Accel:=In_Fly_Ships[i].Accel;
                        Crashed_Ships[j].Score:=In_Fly_Ships[i].score;
                        Crashed_Ships[j].Fly:=True;
                        For l:=1 to 30 do
                            IF NOT Explode_Ships[l].Used Then
                               begin
                                    Explode_Ships[l].used:=True;
                                    Explode_Ships[l].Xpos:=In_Fly_Ships[i].xpos+(In_Fly_Ships[i].anim^[Count].point.y) div 2;
                                    Explode_Ships[l].Ypos:=In_Fly_Ships[i].Ypos+(In_Fly_Ships[i].anim^[Count].point.y) div 2;
                                    Explode_Ships[l].Accel:=In_Fly_Ships[i].accel;
                                    Explode_Ships[l].Add:=0;
                                    Explode_Ships[l].TheEnd:=MAX_Explode;
                                    For k:=1 to MAX_Explode do
                                    begin
                                    Explode_Ships[l].explode[k].Kat:=Random(360);
                                    Explode_Ships[l].explode[k].Odl:=random(20);
                                    Explode_Ships[l].explode[k].max:=random(200);
                                    end;
                                    break;
                               end;
                        break;
                   end;
      end;

   if (Is_in_rectangle(In_Fly_Ships[i].xpos,In_Fly_Ships[i].ypos,
      x_statku,y_statku,x_statku+Fighter_Ship.Anim^[1].xmax,
                        y_statku+Fighter_Ship.Anim^[1].ymax))
      or
      (Is_in_rectangle(In_Fly_Ships[i].xpos+In_Fly_Ships[i].anim^[Count].point.x,
                       In_Fly_Ships[i].ypos+In_Fly_Ships[i].anim^[Count].point.y,
      x_statku,y_statku,x_statku+Fighter_Ship.Anim^[1].xmax,
                        y_statku+Fighter_Ship.Anim^[1].ymax))
      or
      (Is_in_rectangle(In_Fly_Ships[i].xpos+In_Fly_Ships[i].anim^[Count].point.x,
                       In_Fly_Ships[i].ypos,
      x_statku,y_statku,x_statku+Fighter_Ship.Anim^[1].xmax,
                        y_statku+Fighter_Ship.Anim^[1].ymax))
      or
      (Is_in_rectangle(In_Fly_Ships[i].xpos,
                       In_Fly_Ships[i].ypos+In_Fly_Ships[i].anim^[Count].point.x,
      x_statku,y_statku,x_statku+Fighter_Ship.Anim^[1].xmax,
                        y_statku+Fighter_Ship.Anim^[1].ymax))
         then
      begin
            In_Fly_Ships[i].fly:=false;
            For j:=1 to 100 do
                IF NOT Crashed_Ships[j].Fly Then
                   begin
                        Crashed_Ships[j].xpos:=In_Fly_Ships[i].xpos;
                        Crashed_Ships[j].ypos:=In_Fly_Ships[i].ypos;
                        Crashed_Ships[j].count:=1;
                        Crashed_Ships[j].tym:=0;
                        Crashed_Ships[j].Anim:=@Boom_Anim[1].Anim;
                        Crashed_Ships[j].Accel:=In_Fly_Ships[i].Accel;
                        Crashed_Ships[j].Score:=In_Fly_Ships[i].Score;
                        Crashed_Ships[j].Fly:=True;
                        break;
                   end;
      end;

end;

end;


procedure UpDate_Values;                 { Uaktualnienie wartoci na ekranie }
var  stng: string[20];
     w   : word;
begin
     Str(w,Stng);
     put_string_xy(71-length('8888888')*9,69,3,'8888888',Green);
     put_string_xy(71-length(Stng)*9,69,3,stng,LightGreen);   { Scores }
end;


procedure UpDate_Fighter;                    { Wyrysowanie statku ziemskiego }
begin
IF Fighter_Ship.Tym < 1 Then Inc(Fighter_Ship.Tym)   { Opnienie dla klatek }
   Else begin
        Fighter_Ship.Tym:=0;
        repeat
              Inc(Fighter_Ship.Count);       { Nastpna klatka }
              IF Fighter_Ship.Count>3 Then Fighter_Ship.Count:=1;
              IF Fighter_Ship.Anim^[Fighter_Ship.Count].used Then Break;
        until false;
   end;
put_sprite(x_statku,y_statku,Fighter_Ship.Anim^[Fighter_Ship.Count].Point);
end;




(*************************** Procedury M E N U ******************************)
Procedure New_Procedure;
begin
For i:=1 to MAX_Alian_Loaded do
    IF NOT In_Fly_Ships[i].Fly Then
       begin
            In_Fly_Ships[i].Anim:=@Alian_Ship[i].Anim;
            In_Fly_Ships[i].Fly:=True;
            In_Fly_Ships[i].Accel:=2+Random(4);
            In_Fly_Ships[i].Count:=0;
            In_Fly_Ships[i].Score:=Alian_Ship[i].Score;
            In_Fly_Ships[i].Tym:=0;
            repeat
             In_Fly_Ships[i].xpos:=Random(xk-xp)+xp;
            until In_Fly_Ships[i].xpos+Alian_Ship[i].Anim[1].xmax<xk;
            In_Fly_Ships[i].ypos:=-(Random(100)+100);
            inc(MAX_Flying);
       end;
end;

procedure Save_procedure;
begin
end;

procedure Open_procedure;
begin
end;

procedure Help_procedure;
const l00='SPACE SWEEPER:';
      l01='  The Moon''s orbit';
      l03='Credits:';
      l04='';
      l05='';
      l06='';
      l07='Controls:  Keyboard or Joystick';
      l09='    Arrows            : Movements';
      l10='    Ctrl-key,Spacebar : Fire';
      l11='    P,Pause           : Pause';
      l12='    Escape            : Menu';
      l13='    F2                : Save game';
      l14='    F3                : Load game';
      l15='    F10,PrintScreen   : Screenshot';
      xp = 0;
      yp = 0;
      xk = 319;
      yk = 199;
      TxtCol_1st = lightred;
      TxtCol_2nd = Red;
begin
     s_virt:=$a000;
     put_string_shadow(xp+020,yp+020,3,l00,TxtCol_1st,TxtCol_2nd);
     put_string_shadow(xp+140,yp+020,1,l01,TxtCol_1st,TxtCol_2nd);

     put_string_shadow(xp+130,yp+050,1,l03,TxtCol_1st,TxtCol_2nd);
     put_string_shadow(xp+020,yp+100,1,l07,TxtCol_1st,TxtCol_2nd);
     put_string_shadow(xp+020,yp+110,1,l09,TxtCol_1st,TxtCol_2nd);
     put_string_shadow(xp+020,yp+120,1,l10,TxtCol_1st,TxtCol_2nd);
     put_string_shadow(xp+020,yp+130,1,l11,TxtCol_1st,TxtCol_2nd);
     put_string_shadow(xp+020,yp+140,1,l12,TxtCol_1st,TxtCol_2nd);
     put_string_shadow(xp+020,yp+150,1,l13,TxtCol_1st,TxtCol_2nd);
     put_string_shadow(xp+020,yp+160,1,l14,TxtCol_1st,TxtCol_2nd);
     put_string_shadow(xp+020,yp+170,1,l15,TxtCol_1st,TxtCol_2nd);

     readkey;

     s_virt:=Seg(virtual_screen^);
end;



procedure Quit_procedure;
var  ch   : char;
begin
     clear_keyboard;
     memW[$0:$417]:=0;                  { Wyzerowanie stanu specjalnych }
     s_virt:=$a000;
     put_string_shadow(115, 70,1,'Are you sure you',TxtCol_1st,TxtCol_2nd);
     put_string_shadow(115, 80,1,' want quit this',TxtCol_1st,TxtCol_2nd);
     put_string_shadow(115, 90,1,'  great game ?',TxtCol_1st,TxtCol_2nd);
     put_string_shadow(115,100,1,'     (Y/N)',TxtCol_1st,TxtCol_2nd);
repeat
     ch:=readkey;
until UpCase(ch) in [#27,#13,'Y','N'];

IF UpCase(ch) in ['Y',#13] Then begin fade_down; The_End; end;
     s_virt:=Seg(virtual_screen^);
end;




procedure Load_images; (******  Zaadowanie do tablic pointw do image'w  *******)
begin
For i:=1 to MAX_Alian do
    IF Alian_Ship[i].used Then
       begin
            For j:=1 to 3 do
                IF Alian_Ship[i].Anim[j].Used Then
                begin
                   Read_Sprite(sciezka_EXE+Alian_Ship[i].Anim[j].Name,
                                           Alian_Ship[i].Anim[j].Point);
                   Alian_Ship[i].Anim[j].Xmax:=Alian_Ship[i].Anim[j].Point.X;
                   Alian_Ship[i].Anim[j].Ymax:=Alian_Ship[i].Anim[j].Point.Y;
                end;
            Inc(MAX_Alian_Loaded);
       end;

For i:=1 to MAX_Ship do
    IF Space_Ship[i].used Then
       For j:=1 to 3 do
           IF Space_Ship[i].Anim[j].Used Then
       Read_Sprite(sciezka_EXE+Space_Ship[i].Anim[j].Name,
                               Space_Ship[i].Anim[j].Point);

For i:=1 to MAX_Boom do
    IF Boom_Anim[i].used Then
       For j:=1 to 3 do
           IF Boom_Anim[i].Anim[j].Used Then
       Read_Sprite(sciezka_EXE+Boom_Anim[i].Anim[j].Name,
                               Boom_Anim[i].Anim[j].Point);

(*  Zaczepienie statkw do lotu  *)
For i:=1 to MAX_Alian_Loaded do
    IF NOT In_Fly_Ships[i].Fly Then
       begin
            In_Fly_Ships[i].Anim:=@Alian_Ship[i].Anim;
            In_Fly_Ships[i].Fly:=True;
            In_Fly_Ships[i].Accel:=2+Random(4);
            In_Fly_Ships[i].Count:=0;
            In_Fly_Ships[i].Score:=Alian_Ship[i].Score;
            In_Fly_Ships[i].Tym:=0;
            repeat
             In_Fly_Ships[i].xpos:=Random(xk-xp)+xp;
            until In_Fly_Ships[i].xpos+Alian_Ship[i].Anim[1].xmax<xk;
            In_Fly_Ships[i].ypos:=-(Random(100)+100);
            inc(MAX_Flying);
       end;

{IF NOT BETA_Test Then Intro;}

Fighter_Ship.Anim:=@Space_Ship[1].Anim;
Fighter_Ship.Count:=1;

read_sprite(sciezka_EXE+move_back,BMP_tlo);          { Przesuwajce si to }
Read_on_screen(0,0,sciezka_EXE+FightBk,true,true);   { Read na wirtualny i zwolnienie pamici }
                                                     { true - ust. palet, false - wyw zero  }
end;




(***************** Procedury do przyciskw ******************)
constructor T_Button.Init(xpos,ypos: word; text: string; func: pointer);
begin
     xp:=xpos;
     yp:=ypos;
     xk:=xp+Length(text)*4+3*2;
     yk:=yp+10;
     title:=text;
     @run:=func;
     Button_Out;
end;

procedure T_Button.Button_Out;
begin
     Mouse_Event.Hide;
     Line(xp,yk,xk,yk,darkgray);
     Line(xk,yp,xk,yk,darkgray);
     Line(xp,yp,xk,yp,white);
     Line(xp,yp,xp,yk,white);
     Put_Block(xp+1,yp+1,xk,yk,lightgray);
     If @Run<>nil Then
     put_string_shadow(xp+(xk-xp) shr 1-(Length(title)*4) shr 1,yp+3,4,title,white,black)
                  Else
     put_string_shadow(xp+(xk-xp) shr 1-(Length(title)*4) shr 1,yp+3,4,title,LightGray,black);
     Mouse_Event.Show;
end;

procedure T_Button.Button_In;
begin
     Mouse_Event.Hide;
     Line(xp,yk,xk,yk,white);
     Line(xk,yp,xk,yk,white);
     Line(xp,yp,xk,yp,darkgray);
     Line(xp,yp,xp,yk,darkgray);
     Put_Block(xp+1,yp+1,xk,yk,lightgray);
     If @Run<>nil Then
     put_string_shadow(xp+1+(xk-xp) shr 1-(Length(title)*4) shr 1,yp+3,4,title,white,black)
                  Else
     put_string_shadow(xp+1+(xk-xp) shr 1-(Length(title)*4) shr 1,yp+3,4,title,LightGray,black);
     Mouse_Event.Show;
end;

function  T_Button.Pressed(xm,ym: word): boolean;
var  st     : word;
     status : (Runing,Miss,Out);
begin
     status:=Miss;
   repeat
        IF (xm>xp) and (xm<xk) and (ym>yp) and (ym<yk) Then
        begin
             Button_In;
             repeat
                   xm:=Mouse_Event.x shr 1;
                   ym:=Mouse_Event.y;
                   st:=Mouse_Event.ButtonL;
                   If ((xm>xp) and (xm<xk) and
                      (ym>yp) and (ym<yk)) and (st=0) Then
                      begin status:=Runing; break end;
                   If ((xm<xp) or (xm>xk) or
                      (ym<yp) or (ym>yk)) and (st=0) Then
                      begin status:=Miss; break end;
                   If ((xm<xp) or (xm>xk) or
                      (ym<yp) or (ym>yk)) and (st<>0) Then
                      begin status:=out; break end;
             until false;
             Button_out;
        end;
             If status=out then
             begin
                  xm:=Mouse_Event.x shr 1;
                  ym:=Mouse_Event.y;
                  st:=Mouse_Event.ButtonL;
                  If st=0 then break;
             end;
   until status in [miss,runing];

     Pressed:=False;
     If status in [Miss,out] Then exit;
     If @Run<>nil then run;
     Pressed:=True;
end;


function  T_Button.Is_on_button(xm,ym: word): boolean;
begin
     IF (xm>xp) and (xm<xk) and (ym>yp) and (ym<yk) Then Is_on_button:=True
                Else Is_on_button:=False;
end;


constructor T_Scroll.Init(xpos,ypos: word; text: string; func: pointer);
begin
     xp:=xpos;
     yp:=ypos;
     xk:=xp+Length(text)*4+3*2;
     yk:=yp+10;
     title:=text;
     @run:=func;
     Button_Out;
end;


function  T_Scroll.Pressed(xm,ym: word): boolean;
var  st     : word;
     status : (Runing,Miss,Out);
begin
     status:=Miss;
   repeat
        IF (xm>xp) and (xm<xk) and (ym>yp) and (ym<yk) Then
        begin
             Button_In;
             repeat
                   xm:=Mouse_Event.x shr 1;
                   ym:=Mouse_Event.y;
                   st:=Mouse_Event.ButtonL;
                   If ((xm>xp) and (xm<xk) and
                      (ym>yp) and (ym<yk)) and (st<>0) Then
                      begin status:=Runing; end;
                   If (st=0) Then
                      begin status:=Miss; break end;
                   If ((xm<xp) or (xm>xk) or
                      (ym<yp) or (ym>yk)) and (st<>0) Then
                      begin status:=out; break end;
                   If (status=Runing) and (@Run<>nil) then run;
             until false;
             Button_out;
        end;
             If status=out then
             begin
                  xm:=Mouse_Event.x shr 1;
                  ym:=Mouse_Event.y;
                  st:=Mouse_Event.ButtonL;
                  If st=0 then break;
             end;
   until status in [miss,runing];

     Pressed:=False;
     If status in [Miss,out] Then exit;
     Pressed:=True;
end;


function  T_Scroll.Is_on_Button(xm,ym: word): boolean;
begin
     IF (xm>xp) and (xm<xk) and (ym>yp) and (ym<yk) Then Is_on_Button:=True
                Else Is_on_Button:=False;
end;



procedure Beep_Err;
begin
     sound(5000);
     delay(10);
     nosound;
end;

procedure Beep_Ok;
begin
     sound(150);
     delay(50);
     sound(200);
     delay(50);
     sound(300);
     delay(50);
     sound(400);
     delay(50);
     nosound;
end;



(************* Proc obsugi programu **************)
Procedure Rysuj_Statek(i: word);
begin
   xt:=xp+Levels^.Tab[i].x;
   yt:=integer(Accel+yk-Levels^.Tab[i].y);
   wys:=In_Fly_Ships[Levels^.tab[i].Which].Anim^[1].ymax;
   IF (yt<yk-yp) and
      (integer(yt)+wys>yp) Then
   begin
     If (integer(yt+wys)<yk-yp) and (integer(yt)>0)
        then put_sprite(xt,yt,In_Fly_Ships[Levels^.tab[i].which].Anim^[1].Point)
             else
     If (integer(yt+wys)>=yk-yp)
        then put_sprite_from_to(xt,yt,0,yt+wys-(yk-yp),In_Fly_Ships[Levels^.tab[i].which].Anim^[1].Point)
             else
     If (yt+wys>yp)
        then put_sprite_from_to(xt,0,Abs(yt),0,In_Fly_Ships[Levels^.tab[i].which].Anim^[1].Point);
   end;
end;



procedure proc_up_ship;
begin
     IF Alians_pos>1 Then dec(alians_pos)
                     else Beep_Err;
     Mouse_Event.Hide;
     Put_Block(20,90,71,130,black);
     put_sprite(20,90,In_Fly_Ships[Alians_Pos].Anim^[1].Point);
     Mouse_Event.Show;
     delay(200);
end;

procedure proc_down_ship;
begin
     IF Alians_pos<Max_Flying Then inc(alians_pos)
                              Else Beep_Err;
     Mouse_Event.Hide;
     Put_Block(20,90,71,130,black);
     put_sprite(20,90,In_Fly_Ships[Alians_Pos].Anim^[1].Point);
     Mouse_Event.Show;
     delay(200);
end;

procedure proc_quit;
begin
     The_End;
end;


procedure proc_up;
begin
   IF mem[$0:$0417] and 3=0 Then inc(Accel)      { Shift'y }
                            Else inc(Accel,5);
   Mouse_Event.Hide;
   Put_Block(xp,yp,xk,yk,0);

   For i:=1 to Levels^.Max_Flying do Rysuj_Statek(i);

   str(accel,stng);
   put_string_shadow(31,157,4,'00000',0,TxtCol_2nd);
   put_string_shadow(31+length('00000')*4-length(stng)*4,157,4,stng,TxtCol_1st,TxtCol_2nd);

   xm:=Mouse_Event.X shr 1;
   ym:=Mouse_Event.Y;

   Mouse_Event.Show;
end;

procedure proc_down;
begin
   IF mem[$0:$0417] and 3=0 Then          { Shift'y wyczone }
   begin
   If Accel>1 Then Dec(Accel)
              Else begin Accel:=1; Beep_Err; end;
   end else
   begin
   If Accel>6 Then Dec(Accel,5)
              Else begin Accel:=1; Beep_Err; end;
   end;

   Mouse_Event.Hide;
   Put_Block(xp,yp,xk,yk,0);

   For i:=1 to Levels^.Max_Flying do Rysuj_Statek(i);

   str(accel,stng);
   put_string_shadow(31,157,4,'00000',0,TxtCol_2nd);
   put_string_shadow(31+length('00000')*4-length(stng)*4,157,4,stng,TxtCol_1st,TxtCol_2nd);

   xm:=Mouse_Event.X shr 1;
   ym:=Mouse_Event.Y;

   Mouse_Event.Show;
end;

procedure proc_pgup;
begin
   inc(Accel,200);

   Mouse_Event.Hide;
   Put_Block(xp,yp,xk,yk,0);

   For i:=1 to Levels^.Max_Flying do Rysuj_Statek(i);

   str(accel,stng);
   put_string_shadow(31,157,4,'00000',0,TxtCol_2nd);
   put_string_shadow(31+length('00000')*4-length(stng)*4,157,4,stng,TxtCol_1st,TxtCol_2nd);

   xm:=Mouse_Event.X shr 1;
   ym:=Mouse_Event.Y;

   Mouse_Event.Show;
end;

procedure proc_pgdn;
begin
   If integer(Accel-200)>0 Then Dec(Accel,200)
                           else begin Accel:=1; Beep_Err; end;
   Mouse_Event.Hide;
   Put_Block(xp,yp,xk,yk,0);

   For i:=1 to Levels^.Max_Flying do Rysuj_Statek(i);

   str(accel,stng);
   put_string_shadow(31,157,4,'00000',0,TxtCol_2nd);
   put_string_shadow(31+length('00000')*4-length(stng)*4,157,4,stng,TxtCol_1st,TxtCol_2nd);

   xm:=Mouse_Event.X shr 1;
   ym:=Mouse_Event.Y;

   Mouse_Event.Show;
end;


procedure proc_undo;
var  i : word;
begin
     If Levels^.Max_Flying>0 Then Dec(Levels^.Max_Flying)
                             else Beep_Err;
     Mouse_Event.Hide;
     Put_Block(xp,yp,xk,yk,0);

     For i:=1 to Levels^.Max_Flying do Rysuj_Statek(i);

     str(Levels^.Max_Flying,stng);
     put_string_shadow(34,165,4,'0000',0,TxtCol_2nd);
     put_string_shadow(34+length('0000')*4-length(stng)*4,165,4,stng,TxtCol_1st,TxtCol_2nd);

     Mouse_Event.Show;
end;

procedure proc_load;
begin
end;

procedure proc_save;
begin
end;

procedure proc_new;
begin
end;


(******************************  M * A * I * N  *****************************)

begin
Mark(HEAP_state);
init_procedures;
Check_processor;
initgraph256;                       { Init 320x200x256 }
s_virt:=$a000;
put_string_shadow(50,95,1,'Please wait, while loading...',15,2);
s_virt:=seg(virtual_screen^);

load_images;        { Zaadowanie tablic rysunkami }

move_data;
s_virt:=$a000;
Mouse_Event.Init;
Mouse_Event.install;
Button_Up_Ship.init(07,068,  '  UP  ',@proc_up_ship);
Button_Undo.init(40,068,     ' UNDO ',@proc_undo);
Button_Down_Ship.Init(07,141,' DOWN ',@proc_down_ship);

Button_pgup.init(2,yp,   ' PGUP  ',@proc_pgup);
Button_up.init(39,yp,    ' UP    ',@proc_up);
Button_save.init(2,yp+12,' SAVE  ',nil);
Button_load.init(2,yp+24,' LOAD  ',nil);
Button_new.init(2,yp+36, ' NEW   ',nil);
Button_quit.init(2,yp+48,' QUIT  ',@proc_quit);
Button_pgdn.init(2,yk-11,' PGDN  ',@proc_pgdn);
Button_down.init(39,yk-11,' DOWN  ',@proc_down);

Alians_Pos:=1;
Put_Block(20,90,71,130,black);
put_sprite(20,90,In_Fly_Ships[Alians_Pos].Anim^[1].Point);
put_string_shadow(6,157,4,'POS:  00000',TxtCol_1st,TxtCol_2nd);
put_string_shadow(6,165,4,'ALIAN: 0000',TxtCol_1st,TxtCol_2nd);
Mouse_Event.Show;



(***************************)




Mouse_Event.SetXY(10,10);

Levels:=Reserve_Mem(SizeOf(Levels^));

FillChar(Levels^,SizeOf(Levels^),0);
Accel:=1;
tlo.data:=nil;
repeat

freemem(tlo.data,oldsize);
tlo.x:=In_Fly_Ships[Alians_Pos].Anim^[1].xmax;             { Cae to }
tlo.y:=In_Fly_Ships[Alians_Pos].Anim^[1].ymax;
tlo.data:=Reserve_Mem(tlo.x*tlo.y);
oldsize:=tlo.x*tlo.y;
xm:=Mouse_Event.X shr 1;
ym:=Mouse_Event.Y;
If Is_In_Rectangle(xm,ym,xp,yp,xk,yk) Then
begin
Mouse_Event.Hide;
Get_BackGround(xm,ym,tlo,tlo);
Mouse_Event.Show;
xo:=xm;
yo:=ym;
end else xo:=1;

repeat
      {st:=Mouse_Event.ButtonL;
      If st=0 Then} st:=Mouse_Event.PressL;
      xm:=Mouse_Event.X shr 1;
      ym:=Mouse_Event.Y;
      if st<>0 then break;
      IF Is_In_Rectangle(xm,ym,xp,yp,xk,yk) Then
         begin
              IF xm+In_Fly_Ships[Alians_Pos].Anim^[1].xmax>=xk Then continue;
              IF ym+In_Fly_Ships[Alians_Pos].Anim^[1].ymax>=yk Then continue;
              Mouse_Event.Hide;
              If Is_In_Rectangle(xo,yo,xp,yp,xk,yk) Then put_image(xo,yo,tlo);

              Get_BackGround(xm,ym,tlo,tlo);
              put_sprite(xm,ym,In_Fly_Ships[Alians_Pos].Anim^[1].Point);
              rectangle(xm,ym,xm+In_Fly_Ships[Alians_Pos].Anim^[1].xmax-1,
                        ym+In_Fly_Ships[Alians_Pos].Anim^[1].ymax-1,lightgreen);

              xo:=xm;
              yo:=ym;
              repeat
                    xm:=Mouse_Event.X shr 1;
                    ym:=Mouse_Event.Y;
                    st:=Mouse_Event.PressL;
              until (((xm<>xo) and (ym<>yo)) or ((xm<>xo) or (ym<>yo))) or (keypressed) or (st<>0);
              Mouse_Event.Show;
         end;

      IF keypressed Then begin ch:=readkey;
                               If ch=#27 Then the_end;
                         end;
until (st<>0);

IF Is_In_Rectangle(xo,yo,xp,yp,xk,yk) Then  { eby mysza nie mrugaa, gdy }
begin                                       { si nacinie na pustym polu }
     Mouse_Event.Hide;
     put_image(xo,yo,tlo);
     Mouse_Event.Show;
end;

Button_Up_Ship.Pressed(xm,ym);
Button_Undo.Pressed(xm,ym);
Button_Down_Ship.Pressed(xm,ym);

Button_up.Pressed(xm,ym);
Button_pgup.Pressed(xm,ym);
Button_save.Pressed(xm,ym);
Button_load.Pressed(xm,ym);
Button_new.Pressed(xm,ym);
Button_quit.Pressed(xm,ym);
Button_down.Pressed(xm,ym);
Button_pgdn.Pressed(xm,ym);


IF Is_In_Rectangle(xm,ym,xp,yp,xk,yk) Then
   begin
        IF xm+In_Fly_Ships[Alians_Pos].Anim^[1].xmax>=xk Then continue;
        IF ym+In_Fly_Ships[Alians_Pos].Anim^[1].ymax>=yk Then continue;
        inc(Levels^.Max_Flying);
        Levels^.tab[Levels^.Max_Flying].X:=xm-xp;
        Levels^.tab[Levels^.Max_Flying].Y:=Accel+(yk-ym);
        Levels^.tab[Levels^.Max_Flying].Which:=alians_pos;
        Mouse_Event.Hide;
        put_sprite(xm,ym,In_Fly_Ships[Alians_Pos].Anim^[1].Point);

        str(Levels^.Max_Flying,stng);
        put_string_shadow(34,165,4,'0000',0,TxtCol_2nd);
        put_string_shadow(34+length('0000')*4-length(stng)*4,165,4,stng,TxtCol_1st,TxtCol_2nd);

        Mouse_Event.Show;
        Beep_Ok;
   end;

until ch=#27;

Mouse_Event.remove;
Mouse_Event.Hide;
The_End;
end.